רישום חשבונות נגישים

אתם יכולים להציג את הלקוחות שיש לכם גישה אליהם באמצעות ה-method‏ ListAccessibleCustomers ב-CustomerService. עם זאת, חשוב להבין אילו לקוחות מוחזרים בבקשה מהסוג הזה.

הצגת רשימה של לקוחות נגישים היא אחת מהבקשות הבודדות ב-Google Ads API שלא דורשות לציין מספר לקוח בבקשה, והבקשה מתעלמת מכל login-customer-id שסופק.

רשימת הלקוחות שמוצגת מבוססת על פרטי הכניסה שלכם ל-OAuth. הבקשה מחזירה רשימה של כל החשבונות שאתם יכולים לבצע בהם פעולות באופן ישיר, בהתאם לפרטי הכניסה הנוכחיים שלכם. הרשימה הזו לא בהכרח תכלול את כל החשבונות בהיררכיית החשבונות, אלא רק את החשבונות שבהם המשתמש המאומת שלכם נוסף עם הרשאות אדמין או הרשאות אחרות בחשבון.

דוגמה לגישה לחשבון

נניח שאתם המשתמש A, שהוא אדמין של M1 ושל C3 בשתי ההיררכיות שמוצגות באיור. אם תבצעו קריאה ל-Google Ads API, למשל ל-GoogleAdsService, תוכלו לגשת למידע של החשבונות M1,‏ C1,‏ C2 ו-C3. לעומת זאת, קריאה ל-CustomerService.ListAccessibleCustomers תחזיר רק את M1 ו-C3, כי אלה החשבונות היחידים שלמשתמש A יש גישה ישירה אליהם.

הנה דוגמה לקוד שממחיש את השימוש ב-method‏ CustomerService.ListAccessibleCustomers:

Java

private void runExample(GoogleAdsClient client) {
  // Optional: Change credentials to use a different refresh token, to retrieve customers
  //           available for a specific user.
  //
  // UserCredentials credentials =
  //     UserCredentials.newBuilder()
  //         .setClientId("INSERT_OAUTH_CLIENT_ID")
  //         .setClientSecret("INSERT_OAUTH_CLIENT_SECRET")
  //         .setRefreshToken("INSERT_REFRESH_TOKEN")
  //         .build();
  //
  // client = client.toBuilder().setCredentials(credentials).build();

  try (CustomerServiceClient customerService =
      client.getLatestVersion().createCustomerServiceClient()) {
    ListAccessibleCustomersResponse response =
        customerService.listAccessibleCustomers(
            ListAccessibleCustomersRequest.newBuilder().build());

    System.out.printf("Total results: %d%n", response.getResourceNamesCount());

    for (String customerResourceName : response.getResourceNamesList()) {
      System.out.printf("Customer resource name: %s%n", customerResourceName);
    }
  }
}
      

C#‎

public void Run(GoogleAdsClient client)
{
    // Get the CustomerService.
    CustomerServiceClient customerService = client.GetService(Services.V26.CustomerService);

    try
    {
        // Retrieve the list of customer resources.
        string[] customerResourceNames = customerService.ListAccessibleCustomers();

        // Display the result.
        foreach (string customerResourceName in customerResourceNames)
        {
            Console.WriteLine(
                $"Found customer with resource name = '{customerResourceName}'.");
        }
    }
    catch (GoogleAdsException e)
    {
        Console.WriteLine("Failure:");
        Console.WriteLine($"Message: {e.Message}");
        Console.WriteLine($"Failure: {e.Failure}");
        Console.WriteLine($"Request ID: {e.RequestId}");
        throw;
    }
}
      

PHP

public static function runExample(GoogleAdsClient $googleAdsClient)
{
    $customerServiceClient = $googleAdsClient->getCustomerServiceClient();

    // Issues a request for listing all accessible customers.
    $accessibleCustomers =
        $customerServiceClient->listAccessibleCustomers(new ListAccessibleCustomersRequest());
    print 'Total results: ' . count($accessibleCustomers->getResourceNames()) . PHP_EOL;

    // Iterates over all accessible customers' resource names and prints them.
    foreach ($accessibleCustomers->getResourceNames() as $resourceName) {
        /** @var string $resourceName */
        printf("Customer resource name: '%s'%s", $resourceName, PHP_EOL);
    }
}
      

Python

def main(client: GoogleAdsClient) -> None:
    customer_service: CustomerServiceClient = client.get_service(
        "CustomerService"
    )

    accessible_customers: ListAccessibleCustomersResponse = (
        customer_service.list_accessible_customers()
    )
    result_total: int = len(accessible_customers.resource_names)
    print(f"Total results: {result_total}")

    resource_names: List[str] = accessible_customers.resource_names
    for resource_name in resource_names:  # resource_name is implicitly str
        print(f'Customer resource name: "{resource_name}"')
      

Ruby

def list_accessible_customers()
  # GoogleAdsClient will read a config file from
  # ENV['HOME']/google_ads_config.rb when called without parameters
  client = Google::Ads::GoogleAds::GoogleAdsClient.new

  accessible_customers = client.service.customer.list_accessible_customers().resource_names

  accessible_customers.each do |resource_name|
    puts "Customer resource name: #{resource_name}"
  end
end
      

Perl

sub list_accessible_customers {
  my ($api_client) = @_;

  my $list_accessible_customers_response =
    $api_client->CustomerService()->list_accessible_customers();

  printf "Total results: %d.\n",
    scalar @{$list_accessible_customers_response->{resourceNames}};

  foreach
    my $resource_name (@{$list_accessible_customers_response->{resourceNames}})
  {
    printf "Customer resource name: '%s'.\n", $resource_name;
  }

  return 1;
}
      

curl

# Returns the resource names of customers directly accessible by the user
# authenticating the call.
#
# Variables:
#   API_VERSION,
#   OAUTH2_ACCESS_TOKEN:
#     See https://developers.google.com/google-ads/api/rest/auth#request_headers
#     for details.
#
curl -f --request GET \
"https://googleads.googleapis.com/v${API_VERSION}/customers:listAccessibleCustomers" \
--header "Content-Type: application/json" \
--header "Authorization: Bearer ${OAUTH2_ACCESS_TOKEN}" \
      

הצגת רשימה של חשבונות מבוטלים

כדי לאחזר חשבונות שבוטלו ונמצאים בחשבון ניהול, שולחים שאילתה ישירות למשאב customer_client ומסננים לפי status:

SELECT
  customer_client.id,
  customer_client.descriptive_name,
  customer_client.status
FROM customer_client
WHERE customer_client.status = 'CANCELED'